package eserciziArray.esercizio07;

import java.util.Arrays;
import java.util.Random;

/* Testo dell'esercizio:
 * ---------------------
 * 
 * Inizializzare un array di 10 numeri interi
 * 
 * Trovare il numero massimo e stamparlo a video.
 * 
 * Ordinare l’array dal più piccolo al più grande.
 * 
 * Creare un nuovo array di 10 numeri e riempirlo con i numeri 
 * ordinati in modo inverso (dal più grande al più piccolo).
 * 
 * Stampare il secondo array.
 */
public class Esercizio07 {
	private final static Integer MIN_NUMBER=1;
	private final static Integer MAX_NUMBER=100;
	
	private static final Integer ARRAY_LENGTH = 10; 
	
	
	
	private Integer[] arrayA = new Integer[ARRAY_LENGTH];
	private Integer[] arrayB = new Integer[ARRAY_LENGTH];
	
	
	public Esercizio07() {
		//Popola arrayA con numeri casuali
		initArray(arrayA);
		
    	//Ordina arrayA
    	Arrays.sort(arrayA);
    	
    	//Crea arrayB con gli elementi dell'arrayA invertiti 
    	arrayB = getReverseArray(arrayA);
	}
	
	
	/**
	 * Inizializza Array
	 */
    private void initArray(Integer[] arrayDaInizializzare) {
    	int arrayLength = 0;
    	
    	if ( arrayDaInizializzare != null ) {
    		arrayLength = arrayDaInizializzare.length;
    		
        	for (int i=0; i<arrayLength; i++) {
        		arrayDaInizializzare[i] = getNumeroCasuale();
        	}
    		
    	}
    	
    }
    
    
    
    /*
     * Restituisce un nuovo array con gli elementi invertiti.
     */
    private Integer[] getReverseArray(Integer[] arrayDaInvertire) {
    	Integer[] result 				= new Integer[0];
    	int arrayDaInvertireLength 		= 0;
    	
    	if (arrayDaInvertire != null) {
    		arrayDaInvertireLength 	= arrayDaInvertire.length;	
    		result 					= new Integer[arrayDaInvertireLength];
    		
    	    for (int i=0; i<arrayDaInvertireLength; i++) {
    	    	result[arrayDaInvertireLength-i-1] = arrayDaInvertire[i];
    	    }	
    		
    	}
    	
    	return result;
    }
	
	
    
	/**
	 * Genera un numero casuale da MIN_NUMBER a MAX_NUMBER (inclusi)
	 * @return
	 */
    private Integer getNumeroCasuale() {
    	Integer result = 0;
    	
    	Random rand = new Random();
    	result = MIN_NUMBER + rand.nextInt((MAX_NUMBER - MIN_NUMBER) + 1);
    	
    	return result;
    }

	
    
    private String stampaArray(Integer[] arrayDaStampare , String nomeArray) {
    	StringBuffer result = new StringBuffer();
    	
    	result.append("*************************  Stampa Array  ***********************" + "\n");
    	
    	result.append("** " + nomeArray + " = " + "\n");
    	
    	result.append("** ");
    	for ( Integer numero : arrayDaStampare ) {
    		result.append(numero + " ");
    	}
    	result.append("\n");

    	result.append("****************************************************************"  + "\n");
    	
    	return result.toString();
    }
	
    
    private Integer getMaxValueInArray(Integer[] arrayDaAnalizzare) {
    	Integer maxValueFound 	= 0;
    	
    	//Valorizza maxValueFound
    	if (arrayDaAnalizzare != null  && arrayDaAnalizzare.length > 0) {
    		//Caso : Array valido
    		maxValueFound 	= arrayDaAnalizzare[0];
    		
        	for ( Integer numeroLetto : arrayDaAnalizzare ) {
        		if ( numeroLetto > maxValueFound ) {
        			maxValueFound = numeroLetto;
        		}
        	}
    		
    	}
    	
    	return maxValueFound;
    }
    
    
    
    public String getStampaArrayA() {
    	String result = "";
    	
    	result = stampaArray(arrayA, "arrayA");
    	
    	return result;
    }
    
    public String getStampaArrayB() {
    	String result = "";
    	
    	result = stampaArray(arrayB, "arrayB");
    	
    	return result;
    }

    
    
    public Integer getNaxNumberInArrayA() {
    	Integer result = 0;
    	
    	result = getMaxValueInArray(arrayA);
    	
    	return result;
    }
    

}
